#include "BoiteAOutils.h"
#include <wx/intl.h>
#include <wx/tooltip.h>

//---------------------------------------------------------------------------
// Gestion des impressions
//---------------------------------------------------------------------------
// Implmentation du Printout minimal
BasePrintout::BasePrintout(const wxString title = wxT("My printout")):wxPrintout(title){}
//---------------------------------------------------------------------------
float BasePrintout::correctif_preview()
{
    // Correctif pitoyable mais je n'ai pas trouv mieux pour le moment
    #if defined(__WXMSW__)
    return (IsPreview()?1.7:1.6);
    #elif defined(__UNIX__)
    return(IsPreview()?2.0:2.4);
    #endif
}
//---------------------------------------------------------------------------
void BasePrintout::FixeFontEtTaille()
{
    wxDC *dc = GetDC();
    if (dc)
    {
    // la police est mise  l'chelle lors de l'impression
    // cela tient compte des diffrences de dfinition entre l'cran et la page imprime
    // ainsi que de la diffrence de taille entre les deux.
    dc->SetFont(wxFont(10,wxFONTFAMILY_DEFAULT,wxFONTSTYLE_ITALIC,wxFONTWEIGHT_NORMAL,false));
    // le bloc suivant peut tre remplac par l'instruction MapScreenSizeToPage()
    // mais le rsultat semble moins prcis
    int ppiScreenX, ppiScreenY;
    GetPPIScreen(&ppiScreenX, &ppiScreenY);
    int ppiPrinterX, ppiPrinterY;
    GetPPIPrinter(&ppiPrinterX, &ppiPrinterY);
    float scale = (float)((float)ppiPrinterX/(float)ppiScreenX);
    int pageWidth, pageHeight;
    int w, h;
    dc->GetSize(&w, &h);
    GetPageSizePixels(&pageWidth, &pageHeight);
    float overallScale =scale * (float)(w/(float)pageWidth);
    dc->SetUserScale(overallScale, overallScale);
    // Fin du bloc

    //dc->SetFont(wxFont(10,wxFONTFAMILY_DEFAULT,wxFONTSTYLE_ITALIC,wxFONTWEIGHT_NORMAL,false));
    }
}
//---------------------------------------------------------------------------
void BasePrintout::OnPreparePrinting()
{
    FixeFontEtTaille();
}
//---------------------------------------------------------------------------
vecteur fait_vecteur(wxPoint p){return vecteur(p.x,p.y);}
//---------------------------------------------------------------------------
// Fonction gnrant un nombre pseudo alatoire avec une priode plus grande que rand
        int rand_bis()
{
        static unsigned long int graine=rand();
        static unsigned long int xn=graine;
        //xn=( 16807 * xn + 0 ) % 2147483647;
        xn=( 1103515245 * xn + 12345 ) % 2147483647;
        return xn;
}
//---------------------------------------------------------------------------
// mulation de la fonction RandomRange
// retourne un entier dans l'intervalle [min,max[
        int RandomRange_bis(int low,int high)
{
        if (high <low) high=low;
        //return (rand() % (high-low))+low; // utilise le gnrateur de nombre alatoire de la bibliothque standard
        return (rand_bis() % (high-low))+low;
}
//---------------------------------------------------------------------------
//      Implmentation de l'objet Traducteur
//---------------------------------------------------------------------------
        void Traducteur::ajoute_une_entree(wxString Tf,wxString Ta,wxString Te)
{
        Dictionnaire di;
        di.insert(std::make_pair(ang,Ta));
        di.insert(std::make_pair(esp,Te));
        textes.insert(std::make_pair(Tf,di));
}
//---------------------------------------------------------------------------
        Traducteur::Traducteur()
{
        ajoute_une_entree(wxT(" par graduation"),wxT(" per graduation"),wxT("Por gradacin"));
        ajoute_une_entree(wxT("%"),wxT("%"),wxT("%"));
        ajoute_une_entree(wxT("2,0"),wxT("2.0"),wxT("2,0"));
        ajoute_une_entree(wxT("2,5"),wxT("2.5"),wxT("2,5"));
        ajoute_une_entree(wxT("3 mars 1997 / 1 avril 2024"),wxT("3 March 1997 / 1 April 2023"),wxT("3 mayo 1997 / 1 abril 2023"));
        ajoute_une_entree(wxT("A propos"),wxT("About"),wxT("Acerca de"));
        ajoute_une_entree(wxT("Aide"),wxT("Help"),wxT("Ayuda"));
        ajoute_une_entree(wxT("Allle 1"),wxT("Allele 1"),wxT("Alelo 1"));
        ajoute_une_entree(wxT("Allle 2"),wxT("Allele 2"),wxT("Alelo 2"));
        ajoute_une_entree(wxT("Allle 3"),wxT("Allele 3"),wxT("Alelo 3"));
        ajoute_une_entree(wxT("Allle 4"),wxT("Allele 4"),wxT("Alelo 4"));
        ajoute_une_entree(wxT("Annule"),wxT("Cancel"),wxT("Cancela"));
        ajoute_une_entree(wxT("Arrt"),wxT("Stop"),wxT("Parada"));
        ajoute_une_entree(wxT("Avertissement"),wxT("Disclaimer"),wxT("Advertencia"));
        ajoute_une_entree(wxT("DisclaimimageFra.png"),wxT("DisclaimimageEng.png"),wxT("DisclaimimageEsp.png"));
        ajoute_une_entree(wxT("Echap pour interrompre"),wxT("Esc to stop"),wxT("Esc para parar"));
        ajoute_une_entree(wxT("Effectif"),wxT("Headcount"),wxT("Dotacin"));
        ajoute_une_entree(wxT("Effectif Mini"),wxT("Min headcount"),wxT("Min dotacin"));
        ajoute_une_entree(wxT("Effectif Maxi"),wxT("Max headcount"),wxT("Max dotacin"));
        ajoute_une_entree(wxT("Fcondit"),wxT("Fertility"),wxT("Fecundidad"));
        ajoute_une_entree(wxT("Fermer"),wxT("Close"),wxT("Cerrar"));
        ajoute_une_entree(wxT("Fichier d'aide non trouv\n"),wxT("Help file not found\n"),wxT("Archivo de ayuda ausente"));
        ajoute_une_entree(wxT("Fichiers"),wxT("Files"),wxT("Archivos"));
        ajoute_une_entree(wxT("Frquences allliques"),wxT("Incidence"),wxT("Frecuencias allicas"));
        ajoute_une_entree(wxT("gnrations"),wxT("generations"),wxT("generaciones"));
        ajoute_une_entree(wxT("Gntique des populations"),wxT("population Genetics"),wxT("Gentica de las poblaciones"));
        ajoute_une_entree(wxT("genpopfrahlp"),wxT("genpopenghlp"),wxT("genpopesphlp"));
        ajoute_une_entree(wxT("Genpopu.exe"),wxT("Genpopu.exe"),wxT("Genpopu.exe"));
        ajoute_une_entree(wxT("Graphique des Frquences allliques"),wxT("Incidences graphs"),wxT("Grficos de las frecuencias allicas"));
        ajoute_une_entree(wxT("Graphique de l'effectif"),wxT("Roll graph"),wxT("Grfico de la dotacin"));
        ajoute_une_entree(wxT("Impression"),wxT("Print"),wxT("Impresin"));
        ajoute_une_entree(wxT("Lance une mesure"),wxT("Starting a new simulation"),wxT("Arranca una nueva medida"));
        ajoute_une_entree(wxT("Langage"),wxT("Language"),wxT("Idioma"));
        ajoute_une_entree(wxT("Ltalit"),wxT("Lethality"),wxT("Letalidad"));
        ajoute_une_entree(wxT("Mesure"),wxT("Run"),wxT("Medida"));
        ajoute_une_entree(wxT("Modifie"),wxT("Change"),wxT("Cambia"));
        ajoute_une_entree(wxT("Nb d'allles"),wxT("Alleles nb"),wxT("nm alelos"));
        ajoute_une_entree(wxT("Nb gnrations"),wxT("Generations nb"),wxT("nm generaciones"));
        ajoute_une_entree(wxT("Nb individus"),wxT("Number"),wxT("Dotacin"));
        ajoute_une_entree(wxT("Outils"),wxT("Tools"),wxT("Herramientas"));
        ajoute_une_entree(wxT("<-- panmixie -->"),wxT("<-- panmixy -->"),wxT("<-- panmixia -->"));
        ajoute_une_entree(wxT("Panneau de commande"),wxT("Control panel"),wxT("Panel de control"));
        ajoute_une_entree(wxT("Paramtres"),wxT("Control panel"),wxT("Parmetros"));
        ajoute_une_entree(wxT("Prvisualisation"),wxT("Preview"),wxT("Previsualizacin"));
        ajoute_une_entree(wxT("Quitter"),wxT("Exit"),wxT("Cerrar"));
        ajoute_une_entree(wxT("Rglage fin: Ajoute un individu"),wxT("Fine tuning: Add one person"),wxT("Ajuste de precisin: suma un individuo"));
        ajoute_une_entree(wxT("Rglage fin: Enlve un individu"),wxT("Fine tuning: Remove one person"),wxT("Ajuste de precisin: saca a un individuo"));
        ajoute_une_entree(wxT("Rubriques d'aide"),wxT("help topics"),wxT("Temas de ayuda"));
        ajoute_une_entree(wxT("Sans titre"),wxT("untitled"),wxT("Sin ttulo"));
}
//---------------------------------------------------------------------------
        langues& Traducteur::fixe_langue()
{
        static langues Langue_active=fr;
        return Langue_active;
}
//---------------------------------------------------------------------------
        //fixe la langue de dpart
        void Traducteur::langue_demarrage()
{
        bool est_francais(true);
#if defined(__WXMSW__)
        // 1036 pour le franais
        est_francais=(GetSystemDefaultLangID()==1036);
#elif defined(__UNIX__)
        wxString lg;
        wxGetEnv(wxT("LANG"),&lg);
        lg=lg.Left(2);
        est_francais=(lg==wxT("fr"));
#endif
        if (est_francais) fixe_langue()=fr;
                else fixe_langue()=ang;
}
//---------------------------------------------------------------------------
        wxString Traducteur::trad(wxString T)
{
        if (textes.find(T)==textes.end()) return T;
        langues L=fixe_langue();
        if (L==fr) return T;
        return textes[T][L];
}
//---------------------------------------------------------------------------
        wxString Traducteur::trad_tout(wxString T)
{
        wxString traduction=T;
        for(std::map<wxString,Dictionnaire>::iterator i=textes.begin();i!=textes.end();++i)
                if (T==i->first) traduction=trad(T);
                else  for(langues j=suivant(fr);j<=esp;j=suivant(j))
                        if (T==i->second[j])
                                traduction=trad(i->first);
        return traduction;
}
//---------------------------------------------------------------------------
//      Fin de l'objet Traducteur
//---------------------------------------------------------------------------
wxColor& Couleur_Fenetres_defaut()
{
        static wxColor couleur_fen=wxSystemSettings::GetColour(wxSYS_COLOUR_ACTIVEBORDER);
        return couleur_fen;
}
wxRect& Taille_Fenetres_defaut()
{
        //Fixe une position et une taille initiale
        // format pos.x, pos.y, Largeur, Hauteur
        static wxRect taille_fen(250,50,700,600);
        return taille_fen;
}
wxPoint FaitReelle_Pos(wxPoint posvirtuelle,wxWindow* fen)
{
        int X= fen->GetClientSize().GetWidth();
        int Y= fen->GetClientSize().GetHeight();
        return wxPoint(int(posvirtuelle.x*X/1000.0),int(posvirtuelle.y*Y/1000.0));
}
wxSize FaitReelle_Taille(wxSize Sizevirtuelle,wxWindow* fen)
{
        int X= fen->GetClientSize().GetWidth();
        int Y= fen->GetClientSize().GetHeight();
        Sizevirtuelle.Scale(float(X/1000.0),float(Y/1000.0));
        return Sizevirtuelle;
}
void Ajuste_taille_et_pos(wxPoint pos,wxSize taille,wxWindow* fen_mere,wxWindow* fen_fille)
{
        pos=FaitReelle_Pos(pos,fen_mere);
        taille=FaitReelle_Taille(taille,fen_mere);
        fen_fille->SetSize(wxRect(pos,taille));
}
void FixeFontEtTaille(wxWindow* fen)
{
        wxFont Police(fen->GetFont());
        Police.SetPointSize(8);
        fen->SetFont(Police);
}
//---------------------------------------------------------------------------
        PalettePerso::PalettePerso():clDkGray(128,128,128),clCream(255,251,240),clAqua(0,255,255),clLtGray(192,192,192),clRed(255,0,0),clBlack(0,0,0),
                                    clYellow(255,255,0),clLime(0,255,0),clGreen(0,128,0),clBlue(0,0,255)
        {
        }
//---------------------------------------------------------------------------
void RenommeEnfants(wxWindow* Sujet)
{
        Traducteur tr;
        wxToolTip* tt;
        wxFrame* p_frame;
        // Sous Windows Setlabel ajuste correctement le titre des "Frames' mais pas sous Linux
        // d'o la ncessit de distinguer WxXindow et wxFrame
        p_frame=dynamic_cast<wxFrame*>(Sujet);
        if (p_frame!=NULL) // C'est une wxWFrame
            p_frame->SetTitle(tr.trad_tout(p_frame->GetTitle()));
        else // C'est une simple wxWindow
            Sujet->SetLabel(tr.trad_tout(Sujet->GetLabel()));
        tt=Sujet->GetToolTip();
        if (tt!=NULL)
            Sujet->SetToolTip(tr.trad_tout(tt->GetTip()));
        // Mme chose pour les enfants
        wxWindowList list;
        list=Sujet->GetChildren();
        wxWindowList::compatibility_iterator node;
        for (node = list.GetFirst(); node; node = node->GetNext() )
            {
            wxWindow *current = node->GetData();
            RenommeEnfants(current);
            }
}
//---------------------------------------------------------------------------
//      Ajuste la taille de la police  celle de la fentre courante
        void fixe_taille_police(wxDC& dc,float correctif)
        {
        // Correctif introduit pour tenir compte du problme avec la dfinition de l'impression sous Linux
        // en mode impression mais pas en preview. Je n'ai pas trouv mieux pour le moment
        float hauteur_police=8;
        float hauteur_ecran=dc.GetSize().GetHeight();
        float largeur_ecran=dc.GetSize().GetWidth();
        float def_ecran=dc.GetPPI().GetHeight();
        if (hauteur_ecran>largeur_ecran)hauteur_ecran=largeur_ecran; //ne tient compte que de la plus petite dimension
        hauteur_police*=hauteur_ecran/(def_ecran*2*correctif);
        hauteur_police=(hauteur_police<3?3:hauteur_police);
        dc.SetFont(wxFont(int(hauteur_police),wxFONTFAMILY_DEFAULT,wxFONTSTYLE_NORMAL,wxFONTWEIGHT_NORMAL,false));
        }
