#ifndef BOITEAOUTILS_H_INCLUDED
#define BOITEAOUTILS_H_INCLUDED
/*
    Genpopu permet une simulation de l'volution des frquences allliques dans une population.
    Copyright (C) 1997 (version Dos) 2009-2024 (Windows and Linux Versions) Vial Jean-Luc Annecy
    Contact email: vial.frjl@free.fr

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <vector>
#include <map>
#include <complex> // a cause de "vecteur"
#include <wx/string.h>
#include <wx/wx.h>
#include <wx/print.h>
//---------------------------------------------------------------------------
// Dclaration du Printout utilis
class BasePrintout: public wxPrintout
{
 public:
  explicit BasePrintout(const wxString title);
  float correctif_preview();
  void FixeFontEtTaille();
  void OnPreparePrinting();
};
//---------------------------------------------------------------------------
typedef std::complex<double>  vecteur;
//---------------------------------------------------------------------------
vecteur fait_vecteur(wxPoint p);
//---------------------------------------------------------------------------
// Utilitaires divers
template<class Te> Te suivant(Te m)
{
        return (Te(int(m)+1));
}
//---------------------------------------------------------------------------
// mulation de la fonction RandomRange
// retourne un entier dans l'intervalle [min,max[
int RandomRange_bis(int low,int high);
//---------------------------------------------------------------------------
        template<class T> T brasse(T a_brasser)
        {typename T::value_type v;
        int nb_elements=a_brasser.size();
        if (nb_elements)
                {
                for (int i=0;i<nb_elements;i++)
                        {
                        int tirage=RandomRange_bis(i,nb_elements);
                        v=a_brasser[i];
                        a_brasser[i]=a_brasser[tirage];
                        a_brasser[tirage]=v;
                        }
                }
        return a_brasser;
        }
//---------------------------------------------------------------------------
        void RenommeEnfants(wxWindow* Sujet);
//---------------------------------------------------------------------------
// Traducteur
//---------------------------------------------------------------------------
        typedef enum {fr,ang,esp}langues;
        class Traducteur
{
        typedef std::map<langues,wxString> Dictionnaire;
        std::map<wxString,Dictionnaire>textes;
        void ajoute_une_entree(wxString Tf,wxString Ta,wxString Te);
public:
        Traducteur();
        void langue_demarrage();
        langues& fixe_langue();
        wxString trad(wxString T);
        wxString trad_tout(wxString T);
};
//---------------------------------------------------------------------------
// Paramtres globaux
const wxString LF=wxT("\n");
const wxString TAB(wxChar(9));
// Taille et couleur par dfaut des fentres
        wxColor& Couleur_Fenetres_defaut();
        wxRect& Taille_Fenetres_defaut();
        void FixeFontEtTaille(wxWindow* fen);
        class PalettePerso
{
public:
        PalettePerso();
        wxColour clDkGray,clCream,clAqua,clLtGray,clRed,clBlack,clYellow,clLime,clGreen,clBlue;
};
//---------------------------------------------------------------------------
//      Ajuste la taille de la police  celle de la fentre courante
void fixe_taille_police(wxDC& dc,float correctif);
//---------------------------------------------------------------------------
// Conversion taille et position virtuelle sur une grille 1000 x 1000 en taille relle sur la fentre
        wxPoint FaitReelle_Pos(wxPoint posvirtuelle,wxWindow* fen);
        wxSize FaitReelle_Taille(wxSize Sizevirtuelle,wxWindow* fen);
        void Ajuste_taille_et_pos(wxPoint pos,wxSize taille,wxWindow* fen_mere,wxWindow* fen_fille);

#endif //BOITEAOUTILS_H_INCLUDED
