#include "Calcule.h"
#include "ProjetdeBase.h"
#include "ProjetdeBaseApp.h"
#include "Dessin.h"
//---------------------------------------------------------------------------
//      Retourne true une fois tous les n appels
//---------------------------------------------------------------------------
        bool tic_tac(unsigned n)
        {
        static unsigned compteur=0; // le premier appel retournera true
        compteur=(compteur>n?0:compteur);
        return !bool(compteur++);
        }
//---------------------------------------------------------------------------
        Tpopulation population;
//---------------------------------------------------------------------------
//      Dfinition de l'objet Tindividu
//---------------------------------------------------------------------------
        // Constructeur
        Tindividu::Tindividu():sexe(male),allele1(0),allele2(0),marie(false),existe(false){}
//---------------------------------------------------------------------------
        bool Tindividu::homozygote()
                {return allele1==allele2;}
//---------------------------------------------------------------------------
//      Fin de l'objet Tindividu
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//      Dfinition de l'objet Tpopulation
//---------------------------------------------------------------------------
        // Constructeur par dfaut
        Tpopulation::Tpopulation(){}
//---------------------------------------------------------------------------
        // Constructeur de copie
        Tpopulation::Tpopulation(const Tpopulation& popul):contenu(popul.contenu){}
//---------------------------------------------------------------------------
        void Tpopulation::clear() {contenu.clear();}
//---------------------------------------------------------------------------
        unsigned Tpopulation::size() {return contenu.size();}
//---------------------------------------------------------------------------
        bool Tpopulation::pushback(Tindividu nouveau)
        {
        bool possible =(contenu.size()<parametres().effectif_max);
        if (possible) contenu.push_back(nouveau);
        return possible;
        }
//---------------------------------------------------------------------------
        void Tpopulation::Brasse()
        {
        contenu=brasse(contenu);
        }
//---------------------------------------------------------------------------
        float Tpopulation::frequence(int num_allele)
        // Retourne la frquence de l'allle num_allele dans le pool gnique
        // le contrle de l'tat "vivant" est facultatif car seuls des individus
        // avec "existe=true" sont ajouts  contenu
        {float total=0;
        for (unsigned i=0;i<size();i++)
                {Tindividu p=contenu[i];
                total+=(p.allele1==num_allele)+(p.allele2==num_allele);
                }
        total/=(size()*2+0.0001);
        return total;
        }
//---------------------------------------------------------------------------
        float Tpopulation::sex_ratio()
        // retourne le rapport mle/femelle dans la population
        {float resultat=0;
        for (unsigned i=0;i<size();i++)
                if (contenu[i].sexe==male)
                        resultat++;
        resultat/=(size()-unsigned(resultat))+0.001;
        return resultat;
        }
//---------------------------------------------------------------------------
        Tindividu& Tpopulation::operator[](unsigned i)
        {
        return contenu[i];
        }
//---------------------------------------------------------------------------
        Tpopulation& Tpopulation::operator=(const Tpopulation& popul)
        {
        if (this!= &popul)
            {
            contenu=popul.contenu;
            }
        return *this;
        }
//---------------------------------------------------------------------------
        int Tpopulation::panmixie()
        // Retourne 100 si la population est totalement panmictique
        {float resultat=0;
        for (unsigned i=0;i<parametres().nb_alleles();i++)
                for (unsigned j=i;j<parametres().nb_alleles();j++)
                        resultat+=pow((frequence(i)*frequence(j)*(i!=j?2:1)-frequence_genotype(i,j)),2);
        resultat=100-pow(resultat,0.5)*1000;
        resultat=(resultat<0?0:resultat);
        resultat=(resultat>100?100:resultat);
        return int(resultat);
        }
//---------------------------------------------------------------------------
        float Tpopulation::frequence_genotype(int all1,int all2)
        {
        // le contrle de l'tat "vivant" est facultatif car seuls des individus
        // avec "existe=true" sont ajouts  contenu
        float total=0;
        for (unsigned i=0;i<size();i++)
            {Tindividu p=contenu[i];
            total+=(((p.allele1==all1)&&(p.allele2==all2))
                                ||
                    ((p.allele1==all2)&&(p.allele2==all1)));
            }
        return total/(size()+0.0001);
        }
//---------------------------------------------------------------------------
//      Fin de l'objet Tpopulation
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//      Espace de noms Calculs
//---------------------------------------------------------------------------
namespace Calculs
{
//---------------------------------------------------------------------------
double Exp(float x)
        {const long double e=2.718281828;
        return pow(e,x);
        }
//---------------------------------------------------------------------------
double factorielle(unsigned n)
        {double resultat=(n<2?1:n);
        if (n>1) resultat*=factorielle(int(resultat-1));
        return resultat;
        }
//---------------------------------------------------------------------------
        // retourne la valeur de la probabilit pour une valeur i de la variable
        // avec une loi de poisson de paramtre m
double poisson(unsigned i,float m)
        {if ((m==0)&&(i==0)) return 1;
        return pow(m,i)/factorielle(i)*Exp(-1.0*m);
        }
//---------------------------------------------------------------------------
unsigned RandomP(float moyenne, unsigned val_max)
        // Retourne un nombre entre 0 et val_max avec une probabilit
        // correspondant  une loi de Poisson de paramtre "moyenne"
        // Correct pour les valeurs utilises ici.
        // A modifier si elle devait tre utilise dans un cas plus gnral
        {
        static unsigned precision=parametres().facteur_de_precision;
        static float m=0;
        static std::vector<int> abaque(precision);
        // l'abaque n'est reconstruite qu' chaque changement du paramtre moyenne
        // et non  chaque appel de la fonction
        if((moyenne !=m)||(precision!=parametres().facteur_de_precision))
                {
                m=moyenne;
                precision=parametres().facteur_de_precision;
                abaque.resize(precision);
                unsigned index=0;
                for (unsigned i=0;i<=val_max;i++)
                        {
                        double j1=poisson(i,m)*precision;
                        int j=int(j1+0.5);
                        for(int k=0;k<j;k++)
                                {abaque[(k+index<precision?k+index:precision-1)]=i;}
                        index+=j;
                        }
                }
        return abaque[RandomRange_bis(0,precision)];
        }
//---------------------------------------------------------------------------
float teste_RandomP(float moy)
        // Teste la fonction RandomP. (inutile hors des tests)
        {
        //std::vector<unsigned> par_valeur(30);
        unsigned par_valeur[30];
        for (int i=0;i<30;i++) par_valeur[i]=0;
        unsigned precision=parametres().facteur_de_precision*1000;
        double resultat=0,variance=0;
        for(unsigned i=0;i<precision;i++)
                {
                double n=RandomP(moy,10);
                resultat+=n;
                variance+=pow(n-moy,2);
                par_valeur[int(n)]++;
                }
        resultat/=precision;
        //variance/=precision;
        /*
        float valeur,total=0;
        for (unsigned i=0;i<10;i++)
                {valeur=float(par_valeur[i])/precision;
                total+=valeur;
                }
        //teste poisson
        float testrdb[20];
        for (int i=0;i<21;i++) testrdb[i]=0;
        for (int i=0;i<11;i++)
            testrdb[i]=poisson(i,moy);
        // Teste RandomRange_bis
        int testrdb[1000];
        for (int i=0;i<1000;i++) testrdb[i]=0;
        int testrdb1[100];
        for (int i=0;i<100;i++) testrdb1[i]=0;
        for (int i=0;i<10000;i++)
            testrdb[RandomRange_bis(0,1000)]++;
        for (int i=0;i<100;i++)
            {int somme=0;
            for (int j=i*10;j<(i+1)*10;j++)
                somme+=testrdb[j];
            testrdb1[i]=somme;
            }
        resultat=0;
        for(unsigned i=0;i<precision;i++)
                {
                n=RandomRange_bis(0,10);
                resultat+=n;
                }
        //resultat/=precision;
        */
        return resultat;
        }
//---------------------------------------------------------------------------
void    cree_une_population()
        {
        // Cre une population conforme aux paramtres
        population.clear();
        int precision=parametres().facteur_de_precision;
        std::vector<int> abaque(precision); // les lments sont initialiss  0
        int index=0;
        for(unsigned i=0;i<parametres().nb_alleles();i++)
                {
                int j=int(parametres().frequence(i)*precision);
                for (int k=0;k<j;k++)
                        {
                        abaque[k+index]=i;
                        }
                index+=j;
                }
        for (unsigned i=0;i<parametres().effectif_depart;i++)
                {
                Tindividu nouveau_membre;
                nouveau_membre.allele1=abaque[RandomRange_bis(0,precision)];
                nouveau_membre.allele2=abaque[RandomRange_bis(0,precision)];
                nouveau_membre.existe=true;
                nouveau_membre.sexe=(RandomRange_bis(0,precision)>(precision/2)?male:femelle);
                population.pushback(nouveau_membre);
                }
        //population.Brasse();  // prcaution car thoriquement inutile
        }
//---------------------------------------------------------------------------
unsigned cherche_un_conjoint(unsigned n) // retourne 0 si aucun conjoint n'est disponible
        {//Recherche un conjoint  l'individu de rang n plus loin dans la population
        Tindividu elu, a_marier=population[n];
        unsigned numero_elu=0;
        if (population.size()>n+1)
                for (unsigned i=n+1;i<population.size();i++)
                        {elu=population[i];
                        if (elu.existe&&(!elu.marie))
                                if (elu.sexe!=a_marier.sexe)
                                        {numero_elu=i;
                                        i=population.size();
                                        }
                        }
        return numero_elu;
        }
//---------------------------------------------------------------------------
int fixe_nb_enfants()
        {
        return RandomP(parametres().fecondite,parametres().nb_max_enfants);
        }
//---------------------------------------------------------------------------
Tindividu tire_un_genotype(Tindividu p1,Tindividu p2)
        {
        Tindividu enfant;
        enfant.allele1=(RandomRange_bis(0,100)<50?p1.allele1:p1.allele2);
        enfant.allele2=(RandomRange_bis(0,100)<50?p2.allele1:p2.allele2);
        enfant.sexe=(RandomRange_bis(0,100)<50?male:femelle);
        enfant.existe=true;
        return enfant;
        }
//---------------------------------------------------------------------------
void Mesure()
        {
        Tparametres_mesure& pm=parametres();
        cree_une_population(); // cre une population conforme aux paramtres utilisateur
        for (unsigned long int gen=0;gen<pm.nb_generations;gen++) // Pour toutes les gnrations
                {Tpopulation enfants;
                if( !(gen % 10) ) wxGetApp().Yield();// vite les freeze en vidant le tampon messages de Windows
                if (population.size()>0)
                        for (unsigned long int i=0;i<population.size();i++) // Forme les couples
                                {
                                if(!population[i].marie)// Les individus maris forment un couple avec un individu plus en amont
                                        { // dont le cas a dj t trait
                                        population[i].marie=true;// Si on ne lui trouve pas un conjoint c'est que tous les suivants sont du mme sexe
                                        Tindividu parent1=population[i];
                                        if (unsigned long int num=cherche_un_conjoint(i)) // si num=0 aucun conjoint n'est trouv
                                                {population[num].marie=true;
                                                Tindividu parent2=population[num];
                                                int nb_enfants=fixe_nb_enfants(); // Leur donne une descendance
                                                if (nb_enfants>0)
                                                        for(int j=1;j<=nb_enfants;j++)
                                                                {
                                                                Tindividu un_enfant=tire_un_genotype(parent1,parent2);
                                                                if (un_enfant.homozygote())
                                                                        un_enfant.existe=RandomRange_bis(0,pm.facteur_de_precision)>pm.letalite(un_enfant.allele1)*pm.facteur_de_precision;
                                                                if (un_enfant.existe) enfants.pushback(un_enfant);
        // Le contrle du maximum de population est inclus dans la routine pusback de l'objet Tpopulation
                                                                }
                                                }
                                        }
                                }
                population=enfants;// la population des enfants remplace celle des parents
                population.Brasse(); // Sinon la routine cherche un conjoint produirait majoritairement des mariages consanguins
                                    // intressant  dsactiver pour simuler une population favorisant les mariages dans la fratrie.
                // gre les affichages
                firstwin()->Effectif->ajoute_valeur(0,gen,population.size());
                for (unsigned int i=0;i<firstwin()->Frequences->nombre_series();i++)
                        firstwin()->Frequences->ajoute_valeur(i,gen,population.frequence(i)*100);
                firstwin()->Effectif->Update();
                firstwin()->Frequences->Update();
                wxRect R(firstwin()->Frequences->GetRect());
                R.SetHeight(firstwin()->GetSize().GetHeight());
                firstwin()->RefreshRect(R); //Ne rafrachit que la zone des graphiques
                if (tic_tac(10))
                    {
                    firstwin()->ProgressBar1->SetValue(population.panmixie());
                    firstwin()->Refresh(); // rafrachit la totalit de la fentre
                    }
                //la touche Echap ou le bouton stop interrompt la simulation
                if (!firstwin()->calcul_en_cours) gen=pm.nb_generations;
               }
        }
}
//---------------------------------------------------------------------------
//      Fin espace de noms Calculs
//---------------------------------------------------------------------------
