#ifndef MAINFRAME_H_INCLUDED
#define MAINFRAME_H_INCLUDED
/*
    Genpopu permet une simulation de l'volution des frquences allliques dans une population.
    Copyright (C) 1997 (version Dos) 2009-2024 (Windows and Linux Versions) Vial Jean-Luc Annecy
    Contact email: vial.frjl@free.fr

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <wx/wx.h>// headers de wxWidgets
#include "BoiteAOutils.h"

class Tgraphique;
class APropos;
class Reglages;
class wxHtmlHelpController;
//---------------------------------------------------------------------------
// objets propres au programme genpopu
//---------------------------------------------------------------------------
class  Tparametres_mesure
        {unsigned    nb_all; // nombre d'allles maintenu en cohrence avec le conteneur frquence alllique par la fonction nb_alleles
        std::vector<float> frequences_alleliques; // frquences entre 0 et 1;
        std::vector<float> valeur_letalite;// ltalit entre 0 et 1;
        public:
            // Paramtres du programme
        const static unsigned
                facteur_de_precision=1000, //nombre d'lments dans les abaques de tirage au sort
                // valeurs limites pour l'interface.
                limite_sup_nb_generations=1000,
                limite_inf_nb_generations=10,
                limite_sup_effectif=10000,
                limite_inf_effectif=2,
                nb_max_enfants=10;// devrait tre augment si la fcondit maxi tait plus leve
        constexpr static float
                limite_sup_fecondite=2.5,// Fourchette raisonnable mais il est discutable de garder la mme
                limite_inf_fecondite=2.0;// pour des populations petites et trs grandes
            // Valeurs ajustable depuis l'interface
        unsigned
                effectif_depart,
                effectif_max,
                nb_generations;
        float   fecondite;

        bool modification_autorisee;
        Tparametres_mesure();
        unsigned& nb_alleles();
        bool modifie_frequence(unsigned numal,float valeur);
        bool modifie_letalite(unsigned numal,float valeur);
        float frequence(unsigned numal);
        float letalite(unsigned numal);
        bool valeur_modifiee();
        bool operator==(Tparametres_mesure autre_mesure);
        };
//---------------------------------------------------------------------------
// Dfinition de la classe "MainFrame" c'est la fentre principale de l'application
class MainFrame : public wxFrame
{
public:
float valtest;
// Le constructeur
MainFrame();
// Le destructeur
~MainFrame();
        bool init_done;
        bool item_label_change;
        bool item_menu_change;
        bool calcul_en_cours;

        // Aide
        wxHtmlHelpController* helpController;
        // Contrles
        Tgraphique* Frequences;
        Tgraphique* Effectif;
        wxGauge* ProgressBar1;
        void OnStop(wxCommandEvent& event);
private:
        wxString InitDir;
        wxString DonneesDir;
        // Noms par dfaut
        void OnQuit(wxCommandEvent& event);
        void OnImprime(wxCommandEvent& event);
        void OnClose(wxCloseEvent& event);
        void OnMesure(wxCommandEvent& event);
        void OnReglages(wxCommandEvent& event);
        void OnDisclaimer(wxCommandEvent& event);
        void OnAbout(wxCommandEvent& event);
        void OnHelp(wxCommandEvent& event);
        void Onfr(wxCommandEvent& event);
        void Onen(wxCommandEvent& event);
        void Ones(wxCommandEvent& event);
        void OnPaint(wxPaintEvent& event);
        void rafraichit();

        // Identificateurs
        static const long idMenuQuit;
        static const long idMenuImprime;
        static const long idMenuMesure;
        static const long idMenuReglages;
        static const long idMenuStop;
        static const long idMenuDisclaimer;
        static const long idMenuAbout;
        static const long idMenuHelp;
        static const long idMenufr;
        static const long idMenuen;
        static const long idMenues;
        static const long idMenuToolbar1;
        static const long idaproposinst;
        static const long idReglages;
        static const long idOnPaint;
        //identificateurs des diffrents contrles
        static const long idProgressBar1;
        // identifiants des canvas
        static const long idFrequences;
        static const long idEffectifs;
        // Labels
        wxStaticText* Label1;
        wxStaticText* Label1a;
        wxStaticText* Label2;
        wxStaticText* Label2a;
        wxStaticText* Label3;
        wxStaticText* Label3a;
        wxStaticText* Label4;
        wxStaticText* Label4a;
        wxStaticText* Label5;
        wxStaticText* Label5a;

        APropos* AProposinst;
        Reglages* Reglagesinst;
        wxPrintData *g_printData;

        DECLARE_EVENT_TABLE()
};
//---------------------------------------------------------------------------
        MainFrame*& firstwin();// Variable globale retournant un pointeur vers la fentre principale
        Tparametres_mesure& parametres();// Variable globale retournant un pointeur vers les paramtres de mesure
//---------------------------------------------------------------------------
#endif // MAINFRAME_H_INCLUDED
