#include "Reglages.h"
#include "BoiteAOutils.h"
#include "../Icones/genpopu16.xpm"

const int NB_INCR=100; // Nombre de d'incrments sur les curseurs
//---------------------------------------------------------------------------
//Identificateurs
const long Reglages::idBoutonPlus1 = wxNewId();
const long Reglages::idBoutonMoins1 = wxNewId();

const long Reglages::idBarFec= wxNewId();
const long Reglages::idBarEffMin= wxNewId();
const long Reglages::idBarEffMax= wxNewId();
const long Reglages::idBarNbGen= wxNewId();
const long Reglages::idBarNbAll= wxNewId();

const long Reglages::idBarAll1= wxNewId();
const long Reglages::idBarAll1l_Let= wxNewId();

const long Reglages::idBarAll2= wxNewId();
const long Reglages::idBarAll2l_Let= wxNewId();

const long Reglages::idBarAll3= wxNewId();
const long Reglages::idBarAll3l_Let= wxNewId();

const long Reglages::idBarAll4= wxNewId();
const long Reglages::idBarAll4l_Let= wxNewId();

BEGIN_EVENT_TABLE(Reglages, wxFrame)
    EVT_BUTTON(idBoutonPlus1,Reglages::OnBoutonPlus1)
    EVT_BUTTON(idBoutonMoins1,Reglages::OnBoutonMoins1)
    EVT_COMMAND_SCROLL(idBarFec,Reglages::OnBarFec)
    EVT_COMMAND_SCROLL(idBarEffMin,Reglages::OnBarEffMin)
    EVT_COMMAND_SCROLL(idBarEffMax,Reglages::OnBarEffMax)
    EVT_COMMAND_SCROLL(idBarNbGen,Reglages::OnBarNbGen)
    EVT_COMMAND_SCROLL(idBarNbAll,Reglages::OnBarNbAll)
    EVT_COMMAND_SCROLL(idBarAll1,Reglages::OnBarAll1)
    EVT_COMMAND_SCROLL(idBarAll1l_Let,Reglages::OnBarAll1l_Let)
    EVT_COMMAND_SCROLL(idBarAll2,Reglages::OnBarAll2)
    EVT_COMMAND_SCROLL(idBarAll2l_Let,Reglages::OnBarAll2l_Let)
    EVT_COMMAND_SCROLL(idBarAll3,Reglages::OnBarAll3)
    EVT_COMMAND_SCROLL(idBarAll3l_Let,Reglages::OnBarAll3l_Let)
    EVT_COMMAND_SCROLL(idBarAll4,Reglages::OnBarAll4)
    EVT_COMMAND_SCROLL(idBarAll4l_Let,Reglages::OnBarAll4l_Let)
    EVT_PAINT(Reglages::OnPaint)
    EVT_CLOSE(Reglages::OnQuit)
END_EVENT_TABLE()

// Le constructeur
        Reglages::Reglages(wxWindow* parent,wxWindowID idfenReglages):wxFrame(parent,idfenReglages,wxT("Panneau de commande"),wxPoint(300,100),wxDefaultSize,wxFULL_REPAINT_ON_RESIZE|wxDEFAULT_FRAME_STYLE)

{
    FixeFontEtTaille(this);
    wxPoint pos(10,10);
    wxSize taille(20,20); // La valeur de x est utilise sous Windows pour fixer la taille de l'index et n'est pas mise  jour ensuite mme par resize
    SetBackgroundColour(Couleur_Fenetres_defaut());
    wxRect taille_fen=Taille_Fenetres_defaut();
    taille_fen.SetX(taille_fen.GetX());
    taille_fen.SetY(taille_fen.GetY()+taille_fen.GetHeight());
    taille_fen.SetWidth(taille_fen.GetWidth());
    taille_fen.SetHeight(300);
    SetSize(taille_fen);
    SetIcon(genpopu16_xpm);

    // Boutons
    BoutonPlus1=new wxButton(this,idBoutonPlus1,wxT("+"),wxPoint(10,10),wxSize(20,20));
    BoutonMoins1=new wxButton(this,idBoutonMoins1,wxT("-"),wxPoint(10,10),wxSize(20,20));
    // Barrettes de rglage
    // gestion des graduations non gre sous Linux et abandonne au del de wxWidgets 2.9 sous Windows
    // BarFec->SetTickFreq(int(NB_INCR/10)); ne compile plus
    // BarFec= new wxSlider(this,idBarFec,0,0,NB_INCR,wxPoint(10,10),taille,wxSL_AUTOTICKS|wxSL_VERTICAL);
    // WXSL_AUTOTICKS sans effets sous Linux donne des graduations toutes les valeurs sous Windows faute de SetTick fonctionnel
    BarFec= new wxSlider(this,idBarFec,0,0,NB_INCR,wxPoint(10,10),taille,wxSL_VERTICAL);
    BarEffMax= new wxSlider(this,idBarEffMax,0,0,NB_INCR,wxPoint(10,10),taille,wxSL_VERTICAL);
    BarEffMin= new wxSlider(this,idBarEffMin,0,0,NB_INCR,wxPoint(10,10),taille,wxSL_VERTICAL);
    BarNbGen= new wxSlider(this,idBarNbGen,1,0,NB_INCR,wxPoint(10,10),taille,wxSL_VERTICAL);
    BarNbAll= new wxSlider(this,idBarNbAll,2,2,4,wxPoint(10,10),taille,wxSL_AUTOTICKS|wxSL_VERTICAL);

    BarAll1= new wxSlider(this,idBarAll1,0,0,NB_INCR,wxPoint(10,10),taille,wxSL_HORIZONTAL);
    BarAll1l_Let= new wxSlider(this,idBarAll1l_Let,0,0,NB_INCR,wxPoint(10,10),taille,wxSL_HORIZONTAL);

    BarAll2= new wxSlider(this,idBarAll2,0,0,NB_INCR,wxPoint(10,10),taille,wxSL_HORIZONTAL);
    BarAll2l_Let= new wxSlider(this,idBarAll2l_Let,0,0,NB_INCR,wxPoint(10,10),taille,wxSL_HORIZONTAL);

    BarAll3= new wxSlider(this,idBarAll3,0,0,NB_INCR,wxPoint(10,10),taille,wxSL_HORIZONTAL);
    BarAll3l_Let= new wxSlider(this,idBarAll3l_Let,0,0,NB_INCR,wxPoint(10,10),taille,wxSL_HORIZONTAL);

    BarAll4= new wxSlider(this,idBarAll4,0,0,NB_INCR,wxPoint(10,10),taille,wxSL_HORIZONTAL);
    BarAll4l_Let= new wxSlider(this,idBarAll4l_Let,0,0,NB_INCR,wxPoint(10,10),taille,wxSL_HORIZONTAL);

    Positionne_regles();
    // Labels
    taille=wxSize(100,100);
    LabelFec= new wxStaticText(this,wxID_ANY,wxT("Fcondit"),pos,taille,wxST_NO_AUTORESIZE);
    LabelFecMax= new wxStaticText(this,wxID_ANY,wxT("2,5"),pos,taille,wxST_NO_AUTORESIZE);
    LabelFecMin= new wxStaticText(this,wxID_ANY,wxT("2,0"),pos,taille,wxST_NO_AUTORESIZE);
    LabelEffMin= new wxStaticText(this,wxID_ANY,wxT("Effectif Mini"),pos,taille,wxST_NO_AUTORESIZE);
    LabelEffMinMax= new wxStaticText(this,wxID_ANY,wxT("10000"),pos,taille,wxST_NO_AUTORESIZE);
    LabelEffMinMin= new wxStaticText(this,wxID_ANY,wxT("0"),pos,taille,wxST_NO_AUTORESIZE);
    LabelEffMax= new wxStaticText(this,wxID_ANY,wxT("Effectif Maxi"),pos,taille,wxST_NO_AUTORESIZE);
    LabelEffMaxMax= new wxStaticText(this,wxID_ANY,wxT("10000"),pos,taille,wxST_NO_AUTORESIZE);
    LabelEffMaxMin= new wxStaticText(this,wxID_ANY,wxT("0"),pos,taille,wxST_NO_AUTORESIZE);
    LabelNbGen= new wxStaticText(this,wxID_ANY,wxT("Nb gnrations"),pos,taille,wxST_NO_AUTORESIZE);
    LabelNbGenMax= new wxStaticText(this,wxID_ANY,wxT("1000"),pos,taille,wxST_NO_AUTORESIZE);
    LabelNbGenMin= new wxStaticText(this,wxID_ANY,wxT("0"),pos,taille,wxST_NO_AUTORESIZE);
    LabelNbAll= new wxStaticText(this,wxID_ANY,wxT("Nb d'allles"),pos,taille,wxST_NO_AUTORESIZE);
    LabelNbAllMax= new wxStaticText(this,wxID_ANY,wxT("4"),pos,taille,wxST_NO_AUTORESIZE);
    LabelNbAllMin= new wxStaticText(this,wxID_ANY,wxT("2"),pos,taille,wxST_NO_AUTORESIZE);
    LabelFreq= new wxStaticText(this,wxID_ANY,wxT("Frquences allliques"),pos,taille,wxST_NO_AUTORESIZE);
    LabelLetal= new wxStaticText(this,wxID_ANY,wxT("Ltalit"),pos,taille,wxST_NO_AUTORESIZE);
    LabelEchelleHorF= new wxStaticText(this,wxID_ANY,wxT(" 0 %"),pos,taille,wxST_NO_AUTORESIZE);
    LabelEchelleHorFD= new wxStaticText(this,wxID_ANY,wxT("100 %"),pos,taille,wxST_NO_AUTORESIZE);
    LabelEchelleHorL= new wxStaticText(this,wxID_ANY,wxT(" 0 %"),pos,taille,wxST_NO_AUTORESIZE);
    LabelEchelleHorLD= new wxStaticText(this,wxID_ANY,wxT("100 %"),pos,taille,wxST_NO_AUTORESIZE);
    LabelAll_1= new wxStaticText(this,wxID_ANY,wxT("1"),pos,taille,wxST_NO_AUTORESIZE);
    LabelAll_2= new wxStaticText(this,wxID_ANY,wxT("2"),pos,taille,wxST_NO_AUTORESIZE);
    LabelAll_3= new wxStaticText(this,wxID_ANY,wxT("3"),pos,taille,wxST_NO_AUTORESIZE);
    LabelAll_4= new wxStaticText(this,wxID_ANY,wxT("4"),pos,taille,wxST_NO_AUTORESIZE);

}
// Le destructeur
Reglages::~Reglages(){};

//---------------------------------------------------------------------------
void Reglages::Positionne_regles()
{
    BarFec->SetValue(int((parametres().fecondite-parametres().limite_inf_fecondite)/(parametres().limite_sup_fecondite-parametres().limite_inf_fecondite)*NB_INCR));
    int limite_sup_effectif=parametres().limite_sup_effectif;
    BarEffMin->SetValue(int((float(parametres().effectif_depart)/limite_sup_effectif)*NB_INCR));
    BarEffMax->SetValue(int((float(parametres().effectif_max)/limite_sup_effectif)*NB_INCR));
    BarNbGen->SetValue(int((float(parametres().nb_generations)/parametres().limite_sup_nb_generations)*NB_INCR));
    BarNbAll->SetValue(parametres().nb_alleles());
    BarAll3->Show(parametres().nb_alleles()>2);
    BarAll4->Show(parametres().nb_alleles()>3);
    BarAll1->SetValue(int(parametres().frequence(0)*NB_INCR));
    BarAll2->SetValue(int(parametres().frequence(1)*NB_INCR));
    BarAll3->SetValue(int(parametres().frequence(2)*NB_INCR));
    BarAll4->SetValue(int(parametres().frequence(3)*NB_INCR));
    BarAll3l_Let->Show(parametres().nb_alleles()>2);
    BarAll4l_Let->Show(parametres().nb_alleles()>3);
    BarAll1l_Let->SetValue(int(parametres().letalite(0)*NB_INCR));
    BarAll2l_Let->SetValue(int(parametres().letalite(1)*NB_INCR));
    BarAll3l_Let->SetValue(int(parametres().letalite(2)*NB_INCR));
    BarAll4l_Let->SetValue(int(parametres().letalite(3)*NB_INCR));
}
void Reglages::Rafraichit_fenetre_principale()
{
    firstwin()->item_label_change=true;
    firstwin()->Refresh();
    firstwin()->Update();
}
//---------------------------------------------------------------------------
void Reglages::OnBoutonPlus1(wxCommandEvent& event)
{
            // ajoute les individus un par un
        unsigned n=parametres().effectif_depart+1;
        unsigned max=parametres().effectif_max;
        if (parametres().modification_autorisee)
                {parametres().effectif_depart =(n<max?n:max);
                BarEffMin->SetValue(int(float(parametres().effectif_depart)/parametres().limite_sup_effectif*NB_INCR));
                Rafraichit_fenetre_principale();
                }
}
//---------------------------------------------------------------------------
void Reglages::OnBoutonMoins1(wxCommandEvent& event)
{
            //enlve les individus un par un
        unsigned n=parametres().effectif_depart-1;
        unsigned min=parametres().limite_inf_effectif;
        if (parametres().modification_autorisee)
                {
                parametres().effectif_depart =(n<min?min:n);
                BarEffMin->SetValue(int(float(parametres().effectif_depart)/parametres().limite_sup_effectif*NB_INCR));
                Rafraichit_fenetre_principale();
                }
}
//---------------------------------------------------------------------------
    void Reglages::OnBarFec(wxScrollEvent& event)
{
    float n=(float (BarFec->GetValue())*(parametres().limite_sup_fecondite-parametres().limite_inf_fecondite)/NB_INCR+parametres().limite_inf_fecondite);
        if (parametres().modification_autorisee)
                {
                parametres().fecondite=n;
                Rafraichit_fenetre_principale();
                }
}
//---------------------------------------------------------------------------
    void Reglages::OnBarEffMin(wxScrollEvent& event)
{
        unsigned n=int(BarEffMin->GetValue()*(float(parametres().limite_sup_effectif)/NB_INCR)),
                 max=parametres().effectif_max,
                 min=parametres().limite_inf_effectif;
        if (parametres().modification_autorisee)
                {n=(n<min?min:n);
                parametres().effectif_depart =(n<max?n:max);
                BarEffMin->SetValue(int(float(parametres().effectif_depart)/parametres().limite_sup_effectif*NB_INCR));
                Rafraichit_fenetre_principale();
                }
}
//---------------------------------------------------------------------------
    void Reglages::OnBarEffMax(wxScrollEvent& event)
{
        unsigned n=int(BarEffMax->GetValue()*(float(parametres().limite_sup_effectif)/NB_INCR)),
                 min=parametres().effectif_depart;
        if (parametres().modification_autorisee)
                {parametres().effectif_max=(n>min?n:min);
                BarEffMax->SetValue(int(float(parametres().effectif_max)/parametres().limite_sup_effectif*NB_INCR));
                Rafraichit_fenetre_principale();
                }
}
//---------------------------------------------------------------------------
    void Reglages::OnBarNbGen(wxScrollEvent& event)
{
        unsigned n=BarNbGen->GetValue()*(parametres().limite_sup_nb_generations/NB_INCR),
                 min=parametres().limite_inf_nb_generations;
        if (parametres().modification_autorisee)
                {
                parametres().nb_generations=(n<min?min:n);
                BarNbGen->SetValue(int(float(parametres().nb_generations)/parametres().limite_sup_nb_generations*NB_INCR));
                Rafraichit_fenetre_principale();
                }
}
//---------------------------------------------------------------------------
    void Reglages::OnBarNbAll(wxScrollEvent& event)
{
            if (parametres().modification_autorisee)
                {
                int nb_choisi=BarNbAll->GetValue(),
                    nb_courant=parametres().nb_alleles();
                if (nb_choisi!=nb_courant)
                    {
                    parametres().nb_alleles()=nb_choisi;
                    Positionne_regles();
                    Rafraichit_fenetre_principale();// le premier rafrachissement met  jour le nombre de sries
                    Rafraichit_fenetre_principale();// aprs avoir appel le onpaint de la zone graphique
                    }
                }
}
//---------------------------------------------------------------------------
    void Reglages::OnBarAll1(wxScrollEvent& event)
{
        unsigned n=BarAll1->GetValue();
        if (parametres().modification_autorisee)
                {
                parametres().modifie_frequence(0,float(n)/100);
                Positionne_regles();
                }
}
//---------------------------------------------------------------------------
    void Reglages::OnBarAll1l_Let(wxScrollEvent& event)
{
        unsigned n=BarAll1l_Let->GetValue();
        if (parametres().modification_autorisee)
                parametres().modifie_letalite(0,float(n)/100);
}
//---------------------------------------------------------------------------
    void Reglages::OnBarAll2(wxScrollEvent& event)
{
        unsigned n=BarAll2->GetValue();
        if (parametres().modification_autorisee)
                {
                parametres().modifie_frequence(1,float(n)/100);
                Positionne_regles();
                }
}
//---------------------------------------------------------------------------
    void Reglages::OnBarAll2l_Let(wxScrollEvent& event)
{
        unsigned n=BarAll2l_Let->GetValue();
        if (parametres().modification_autorisee)
                parametres().modifie_letalite(1,float(n)/100);
}
//---------------------------------------------------------------------------
    void Reglages::OnBarAll3(wxScrollEvent& event)
{
        unsigned n=BarAll3->GetValue();
        if (parametres().modification_autorisee)
                {
                parametres().modifie_frequence(2,float(n)/100);
                Positionne_regles();
                }
}
//---------------------------------------------------------------------------
    void Reglages::OnBarAll3l_Let(wxScrollEvent& event)
{
        unsigned n=BarAll3l_Let->GetValue();
        if (parametres().modification_autorisee)
                parametres().modifie_letalite(2,float(n)/100);
}
//---------------------------------------------------------------------------
    void Reglages::OnBarAll4(wxScrollEvent& event)
{
        unsigned n=BarAll4->GetValue();
        if (parametres().modification_autorisee)
                {
                parametres().modifie_frequence(3,float(n)/100);
                Positionne_regles();
                }
}
//---------------------------------------------------------------------------
    void Reglages::OnBarAll4l_Let(wxScrollEvent& event)
{
        unsigned n=BarAll4l_Let->GetValue();
        if (parametres().modification_autorisee)
                parametres().modifie_letalite(3,float(n)/100);
}
//------------------------3 mars 1997 / 10 fvrier 2---------------------------------------------------
void Reglages::OnPaint(wxPaintEvent& event)
{
    wxPaintDC dc(this);
    Traducteur tr;
    // Ajuste la taille des contrles
    int pas =120;
    int lonbar=680;
    Ajuste_taille_et_pos(wxPoint(10,300),wxSize(50,lonbar),this,BarFec);
    Ajuste_taille_et_pos(wxPoint(10,200),wxSize(100,80),this,LabelFec);
    Ajuste_taille_et_pos(wxPoint(70,310),wxSize(50,80),this,LabelFecMin);
    Ajuste_taille_et_pos(wxPoint(70,920),wxSize(50,80),this,LabelFecMax);

    Ajuste_taille_et_pos(wxPoint(10+pas+30,200),wxSize(60,90),this,BoutonPlus1);
    Ajuste_taille_et_pos(wxPoint(10+pas-30,200),wxSize(60,90),this,BoutonMoins1);
    Ajuste_taille_et_pos(wxPoint(10+pas,300),wxSize(50,lonbar),this,BarEffMin);
    Ajuste_taille_et_pos(wxPoint(10+pas,100),wxSize(100,80),this,LabelEffMin);
    Ajuste_taille_et_pos(wxPoint(70+pas,310),wxSize(50,80),this,LabelEffMinMin);
    Ajuste_taille_et_pos(wxPoint(70+pas,920),wxSize(50,80),this,LabelEffMinMax);

    Ajuste_taille_et_pos(wxPoint(10+2*pas,300),wxSize(50,lonbar),this,BarEffMax);
    Ajuste_taille_et_pos(wxPoint(10+2*pas,200),wxSize(100,80),this,LabelEffMax);
    Ajuste_taille_et_pos(wxPoint(70+2*pas,310),wxSize(50,80),this,LabelEffMaxMin);
    Ajuste_taille_et_pos(wxPoint(70+2*pas,920),wxSize(50,80),this,LabelEffMaxMax);

    Ajuste_taille_et_pos(wxPoint(10+3*pas,300),wxSize(50,lonbar),this,BarNbGen);
    Ajuste_taille_et_pos(wxPoint(10+3*pas,100),wxSize(150,80),this,LabelNbGen);
    Ajuste_taille_et_pos(wxPoint(70+3*pas,310),wxSize(50,80),this,LabelNbGenMin);
    Ajuste_taille_et_pos(wxPoint(70+3*pas,920),wxSize(50,80),this,LabelNbGenMax);

    Ajuste_taille_et_pos(wxPoint(10+4*pas,300),wxSize(50,lonbar),this,BarNbAll);
    Ajuste_taille_et_pos(wxPoint(10+4*pas,200),wxSize(100,80),this,LabelNbAll);
    Ajuste_taille_et_pos(wxPoint(70+4*pas,310),wxSize(50,80),this,LabelNbAllMin);
    Ajuste_taille_et_pos(wxPoint(70+4*pas,920),wxSize(50,80),this,LabelNbAllMax);

    pas=160;lonbar=190;
    Ajuste_taille_et_pos(wxPoint(650,100),wxSize(150,80),this,LabelFreq);
    Ajuste_taille_et_pos(wxPoint(650+int(lonbar*1.2),100),wxSize(100,80),this,LabelLetal);

    Ajuste_taille_et_pos(wxPoint(600,200),wxSize(50,80),this,LabelEchelleHorL);
    Ajuste_taille_et_pos(wxPoint(600+lonbar-50,200),wxSize(50,80),this,LabelEchelleHorLD);
    Ajuste_taille_et_pos(wxPoint(600+lonbar+50,200),wxSize(50,80),this,LabelEchelleHorF);
    Ajuste_taille_et_pos(wxPoint(600+2*lonbar-40,200),wxSize(50,80),this,LabelEchelleHorFD);

    Ajuste_taille_et_pos(wxPoint(600+lonbar,300),wxSize(20,80),this,LabelAll_1);
    Ajuste_taille_et_pos(wxPoint(600,300),wxSize(lonbar,pas-10),this,BarAll1);
    Ajuste_taille_et_pos(wxPoint(600+lonbar+20,300),wxSize(lonbar,pas-10),this,BarAll1l_Let);

    Ajuste_taille_et_pos(wxPoint(600+lonbar,300+pas),wxSize(20,80),this,LabelAll_2);
    Ajuste_taille_et_pos(wxPoint(600,300+pas),wxSize(lonbar,pas-10),this,BarAll2);
    Ajuste_taille_et_pos(wxPoint(600+lonbar+20,300+pas),wxSize(lonbar,pas-10),this,BarAll2l_Let);

    Ajuste_taille_et_pos(wxPoint(600+lonbar,300+2*pas),wxSize(20,80),this,LabelAll_3);
    Ajuste_taille_et_pos(wxPoint(600,300+2*pas),wxSize(lonbar,pas-10),this,BarAll3);
    Ajuste_taille_et_pos(wxPoint(600+lonbar+20,300+2*pas),wxSize(lonbar,pas-10),this,BarAll3l_Let);

    Ajuste_taille_et_pos(wxPoint(600+lonbar,300+3*pas),wxSize(20,80),this,LabelAll_4);
    Ajuste_taille_et_pos(wxPoint(600,300+3*pas),wxSize(lonbar,pas-10),this,BarAll4);
    Ajuste_taille_et_pos(wxPoint(600+lonbar+20,300+3*pas),wxSize(lonbar,pas-10),this,BarAll4l_Let);
}
//---------------------------------------------------------------------------
void Reglages::OnQuit(wxCloseEvent& event)
{
    Hide();
}
